const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const qa_checklists = sequelize.define(
    'qa_checklists',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

checklist_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"incoming",


"in_process",


"final",


"audit"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"active",


"inactive"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  qa_checklists.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























    db.qa_checklists.hasMany(db.qa_checklist_items, {
      as: 'qa_checklist_items_qa_checklist',
      foreignKey: {
          name: 'qa_checklistId',
      },
      constraints: false,
    });







//end loop






    db.qa_checklists.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.qa_checklists.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return qa_checklists;
};


